diff -uNr mythtv-0.21/libs/libmythtv/NuppelVideoPlayer.cpp mythtv/libs/libmythtv/NuppelVideoPlayer.cpp
--- mythtv-0.21/libs/libmythtv/NuppelVideoPlayer.cpp	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/libs/libmythtv/NuppelVideoPlayer.cpp	2008-12-31 21:12:34.000000000 +0100
@@ -145,6 +145,8 @@
       m_playbackinfo(NULL),
       // Window stuff
       parentWidget(NULL), embedid(0), embx(-1), emby(-1), embw(-1), embh(-1),
+      embed_saved_scan_type((FrameScanType)-2),
+      embed_saved_scan_lock(false),
       // State
       eof(false),
       m_double_framerate(false),    m_double_process(false),
@@ -741,6 +743,9 @@
     }
 
     InitFilters();
+
+    if (ringBuffer->InDVDMenuOrStillFrame())
+        ringBuffer->DVD()->SetRunSeekCellStart(true);
 }
 
 QString NuppelVideoPlayer::ReinitAudio(void)
@@ -996,8 +1001,11 @@
         return;
     }
 
-    video_dim    = QSize((width + 15) & ~0xf, (height + 15) & ~0xf);
-    video_disp_dim=QSize(width, height);
+    if ((width > 0) && (height > 0))
+    {
+        video_dim      = QSize((width + 15) & ~0xf, (height + 15) & ~0xf);
+        video_disp_dim = QSize(width, height);
+    }
     video_aspect = (aspect > 0.0f) ? aspect : video_aspect;
     keyframedist = (keyframedistance > 0) ? keyframedistance : keyframedist;
 
@@ -1585,6 +1593,16 @@
 {
     if (videoOutput)
     {
+        // BEGIN HACK -- Temporarily disable deinterlacing
+        // Note: this should no longer be needed after mythtv-vid merge
+        if ((int)embed_saved_scan_type <= kScan_Ignore)
+        {
+            embed_saved_scan_type = m_scan;
+            embed_saved_scan_lock = m_scan_locked;
+            SetScanType(kScan_Progressive);
+        }
+        // END HACK
+
         videoOutput->EmbedInWidget(wid, x, y, w, h);
     }
     else
@@ -1602,6 +1620,17 @@
     if (videoOutput)
     {
         videoOutput->StopEmbedding();
+
+        // BEGIN HACK -- Temporarily disable deinterlacing
+        // Note: this should no longer be needed after mythtv-vid merge
+        if ((int)embed_saved_scan_type >= kScan_Ignore)
+        {
+            SetScanType(embed_saved_scan_type);
+            m_scan_locked = embed_saved_scan_lock;
+            embed_saved_scan_type = (FrameScanType) -2;
+        }
+        // END HACK
+
         ReinitOSD();
     }
 }
@@ -2435,6 +2464,9 @@
             }
 
             avsync_delay = (buffer->timecode - currentaudiotime) * 1000;//usec
+            // prevents major jitter when pts resets during dvd title
+            if (avsync_delay > 2000000 && ringBuffer->isDVD())
+                avsync_delay = 90000;
             avsync_avg = (avsync_delay + (avsync_avg * 3)) / 4;
             if (!usevideotimebase)
             {
@@ -2507,8 +2539,7 @@
         return;
     }
 
-    if (ringBuffer->InDVDMenuOrStillFrame())
-        DisplayDVDButton();
+    DisplayDVDButton();
 
     videofiltersLock.lock();
     videoOutput->ProcessFrame(NULL, osd, videoFilters, pipplayer);
@@ -2524,7 +2555,8 @@
     prebuffering_lock.lock();
     if (prebuffering)
     {
-        if (ringBuffer->InDVDMenuOrStillFrame() && prebuffer_tries > 3)
+        if (ringBuffer->InDVDMenuOrStillFrame() && 
+            prebuffer_tries > 3)
         {
             prebuffering = false;
             prebuffer_tries = 0;
@@ -2532,7 +2564,8 @@
             return true;
         }
 
-        if (!audio_paused && audioOutput)
+        if (!ringBuffer->InDVDMenuOrStillFrame() && 
+            !audio_paused && audioOutput)
         {
            if (prebuffering)
                 audioOutput->Pause(prebuffering);
@@ -2663,8 +2696,7 @@
         yuv_wait.wakeAll();
     }
 
-    if (ringBuffer->InDVDMenuOrStillFrame())
-        DisplayDVDButton();
+    DisplayDVDButton();
 
     // handle Interactive TV
     if (GetInteractiveTV() && GetDecoder())
@@ -2835,9 +2867,6 @@
 
                 if (ringBuffer->InDVDMenuOrStillFrame())
                 {
-                    if (audioOutput)
-                        audioOutput->Pause(false);
-
                     if (nbframes == 0)
                     {
                         VERBOSE(VB_PLAYBACK, LOC_ERR + 
@@ -3795,8 +3824,11 @@
 
     int samples = len / samplesize;
 
-    if (ringBuffer->InDVDMenuOrStillFrame())
+    if (ringBuffer->isDVD() &&
+        ringBuffer->DVD()->InStillFrame())
+    {
         audioOutput->Drain();
+    }
 
     // If there is no warping, just send it to the audioOutput.
     if (!usevideotimebase)
@@ -4493,7 +4525,14 @@
         audioOutput->Reset();
 
     if (osd)
+    {
         osd->ClearAllCCText();
+        if (ringBuffer->InDVDMenuOrStillFrame())
+        {
+            osd->HideSet("subtitles");
+            osd->ClearAll("subtitles");
+        }
+    }
 
     SetDeleteIter();
     SetCommBreakIter();
@@ -4529,20 +4568,22 @@
 {
     if (hascommbreaktable)
     {
+
         commBreakIter = commBreakMap.begin();
         while (commBreakIter != commBreakMap.end())
         {
-            if ((framesPlayed + 2) > commBreakIter.key())
-            {
-                commBreakIter++;
-            }
-            else
+            if (framesPlayed <= commBreakIter.key())
                 break;
-        }
 
-        VERBOSE(VB_COMMFLAG, LOC + QString("new commBreakIter = %1 @ frame %2")
+            commBreakIter++;
+	}
+
+	if (commBreakIter != commBreakMap.end())
+	{
+            VERBOSE(VB_COMMFLAG, LOC + QString("new commBreakIter = %1 @ frame %2")
                                            .arg(commBreakIter.data())
                                            .arg(commBreakIter.key()));
+        }
     }
 }
 
@@ -6970,15 +7011,15 @@
 
 void NuppelVideoPlayer::DisplayDVDButton(void)
 {
-    if (!ringBuffer->InDVDMenuOrStillFrame() || !osd)
+    if (!ringBuffer->isDVD() || !osd)
         return;
 
     VideoFrame *buffer = videoOutput->GetLastShownFrame();
 
-    int numbuttons = ringBuffer->DVD()->NumMenuButtons();
+    bool numbuttons = ringBuffer->DVD()->NumMenuButtons();
     bool osdshown = osd->IsSetDisplaying("subtitles");
 
-    if ((numbuttons == 0) || 
+    if ((!numbuttons) || 
         (osdshown) ||
         (dvd_stillframe_showing && buffer->timecode > 0) ||
         ((!osdshown) && 
@@ -6990,39 +7031,40 @@
     }
 
     OSDSet *subtitleOSD = NULL;
-    AVSubtitleRect *highlightButton = ringBuffer->DVD()->GetMenuButton();
-
-    if (highlightButton != NULL)
+    AVSubtitle *dvdSubtitle = ringBuffer->DVD()->GetMenuSubtitle();
+    AVSubtitleRect *hl_button = NULL;
+    if (dvdSubtitle != NULL)
     {
+        hl_button = &(dvdSubtitle->rects[0]);
         osd->HideSet("subtitles");
         osd->ClearAll("subtitles");
         subtitleLock.lock();
-        uint h = ringBuffer->DVD()->ButtonHeight();
-        uint w = ringBuffer->DVD()->ButtonWidth();
-        uint bitmapHeight = highlightButton->h;
-        uint bitmapWidth  = highlightButton->w;
-        int linesize = highlightButton->linesize;
-        int x1 = highlightButton->x;
-        int y1 = highlightButton->y;
-        uint btnX = ringBuffer->DVD()->ButtonPosX();
-        uint btnY = ringBuffer->DVD()->ButtonPosY();
+        uint h = hl_button->h;
+        uint w  = hl_button->w;
+        int linesize = hl_button->linesize;
+        int x1 = hl_button->x;
+        int y1 = hl_button->y;
+        QRect buttonPos = ringBuffer->DVD()->GetButtonCoords();
         subtitleOSD = osd->GetSet("subtitles");
-
-        if ((w + x1) > bitmapWidth)
-            w = w - ((w + x1) - bitmapWidth);
-       
-        if ((h + y1) > bitmapHeight)
-            h = h - ((h + y1) - bitmapHeight);
-        
-        QImage hl_button(w, h, 32);
-        hl_button.setAlphaBuffer(true);
-        for (uint y = 0; y < h; y++)
+        QImage hl_image(w, h, 32);
+        hl_image.setAlphaBuffer(true);
+        uint8_t color;
+        uint32_t pixel;
+        QPoint currentPos = QPoint(0,0);
+        for (uint y = 2; y < h; y++)
         {
             for (uint x = 0; x < w; x++)
             {
-                uint8_t color = highlightButton->bitmap[(y+y1)*linesize+(x+x1)];
-                uint32_t pixel = highlightButton->rgba_palette[color];
-                hl_button.setPixel(x, y, pixel);
+                currentPos.setY(y);
+                currentPos.setX(x);
+                color = hl_button->bitmap[(y)*linesize+(x)];
+                // use rgba palette from dvd nav for drawing
+                // highlighted button
+                if (buttonPos.contains(currentPos))
+                    pixel = dvdSubtitle->rects[1].rgba_palette[color];
+                else
+                    pixel = hl_button->rgba_palette[color];
+                hl_image.setPixel(x, y, pixel);
             }
         }
 
@@ -7037,19 +7079,19 @@
 
         if ((hmult < 0.99) || (hmult > 1.01) || (vmult < 0.99) || (vmult > 1.01)) 
         {
-            btnX = (int)    (btnX * hmult);
-            btnY = (int)    (btnY * vmult);
+            x1 = (int)    (x1 * hmult);
+            y1 = (int)    (y1 * vmult);
             w    = (int)ceil(w    * hmult);
             h    = (int)ceil(h    * vmult);
 
-            hl_button = hl_button.smoothScale(w, h);
+            hl_image = hl_image.smoothScale(w, h);
         } 
         else 
             hmult = vmult = 1.0;
 
         OSDTypeImage* image = new OSDTypeImage();
-        image->SetPosition(QPoint(btnX, btnY), hmult, vmult);
-        image->Load(hl_button);
+        image->SetPosition(QPoint(x1, y1), hmult, vmult);
+        image->Load(hl_image);
         image->SetDontRoundPosition(true);
 
         subtitleOSD->AddType(image);
diff -uNr mythtv-0.21/libs/libmythtv/NuppelVideoPlayer.h mythtv/libs/libmythtv/NuppelVideoPlayer.h
--- mythtv-0.21/libs/libmythtv/NuppelVideoPlayer.h	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/libs/libmythtv/NuppelVideoPlayer.h	2008-10-05 04:00:28.000000000 +0200
@@ -527,7 +527,8 @@
     QWidget *parentWidget;
     WId embedid;
     int embx, emby, embw, embh;
-
+    FrameScanType embed_saved_scan_type;
+    bool          embed_saved_scan_lock;
 
     // State
     QWaitCondition decoderThreadPaused;
diff -uNr mythtv-0.21/libs/libmythtv/NuppelVideoRecorder.cpp mythtv/libs/libmythtv/NuppelVideoRecorder.cpp
--- mythtv-0.21/libs/libmythtv/NuppelVideoRecorder.cpp	2008-01-25 08:02:26.000000000 +0100
+++ mythtv/libs/libmythtv/NuppelVideoRecorder.cpp	2008-12-06 19:46:03.000000000 +0100
@@ -981,28 +981,25 @@
             correct_bttv = true;
 
         QString driver = (char *)vcap.driver;
-        if (driver == "cx8800" || driver == "go7007" || driver == "em28xx")
+        channelfd = open(videodevice.ascii(), O_RDWR);
+        if (channelfd < 0)
         {
-            channelfd = open(videodevice.ascii(), O_RDWR);
-            if (channelfd < 0)
-            {
-                VERBOSE(VB_IMPORTANT, LOC_ERR +
-                        QString("Can't open video device: %1").arg(videodevice));
-                perror("open video:");
-                KillChildren();
-                return false;
-            }
-
-            if (driver == "go7007")
-            {
-                go7007 = true;
-            }
-            
-            inpixfmt = FMT_NONE;
-            InitFilters();
-            DoV4L2();
+            VERBOSE(VB_IMPORTANT, LOC_ERR +
+                    QString("Can't open video device: %1").arg(videodevice));
+            perror("open video:");
+            KillChildren();
             return false;
         }
+
+        if (driver == "go7007")
+        {
+            go7007 = true;
+        }
+ 
+        inpixfmt = FMT_NONE;
+        InitFilters();
+        DoV4L2();
+        return false;
     }
 
     channelfd = fd;
diff -uNr mythtv-0.21/libs/libmythtv/playgroup.cpp mythtv/libs/libmythtv/playgroup.cpp
--- mythtv-0.21/libs/libmythtv/playgroup.cpp	2007-11-19 17:44:58.000000000 +0100
+++ mythtv/libs/libmythtv/playgroup.cpp	2008-12-16 21:47:33.000000000 +0100
@@ -114,7 +114,12 @@
 
     virtual void save(void) {
         if (intValue() < 50 || intValue() > 200)
-            setValue(0);
+        {
+            // We need to bypass the bounds checking that would
+            // normally occur in order to get the special value of 0
+            // into the database
+            IntegerSetting::setValue(0);
+        }
         PlayGroupDBStorage::save();
     }
 };
diff -uNr mythtv-0.21/libs/libmythtv/progfind.cpp mythtv/libs/libmythtv/progfind.cpp
--- mythtv-0.21/libs/libmythtv/progfind.cpp	2008-01-14 17:45:33.000000000 +0100
+++ mythtv/libs/libmythtv/progfind.cpp	2009-04-07 18:39:21.000000000 +0200
@@ -1425,6 +1425,8 @@
 {
     if (data.right(5) == ", The")
         data = "The " + data.left(data.length() - 5);
+    if (data.right(4) == ", An")
+        data = "An " + data.left(data.length() - 4);
     if (data.right(3) == ", A")
         data = "A " + data.left(data.length() - 3);
 }
diff -uNr mythtv-0.21/libs/libmythtv/programinfo.cpp mythtv/libs/libmythtv/programinfo.cpp
--- mythtv-0.21/libs/libmythtv/programinfo.cpp	2008-02-15 01:30:26.000000000 +0100
+++ mythtv/libs/libmythtv/programinfo.cpp	2009-02-21 06:18:28.000000000 +0100
@@ -1530,7 +1530,9 @@
         if (!query.exec() || !query.isActive())
             MythContext::DBError("GetRecordBasename", query);
         else if (query.size() < 1)
-            VERBOSE(VB_IMPORTANT, QString("GetRecordBasename found no entry"));
+            VERBOSE(VB_IMPORTANT, QString("GetRecordBasename found no entry "
+                    "for %1 @ %2")
+                    .arg(chanid).arg(recstartts.toString(Qt::ISODate)));
         else
         {
             query.next();
@@ -1551,6 +1553,9 @@
     QString tmpURL;
     QString basename = GetRecordBasename(true);
 
+    if (basename == "")
+        return "";
+
     bool alwaysStream = gContext->GetNumSetting("AlwaysStreamFiles", 0);
 
     if ((!alwaysStream) ||
@@ -1569,8 +1574,9 @@
         }
         else if (hostname == gContext->GetHostName())
         {
-            VERBOSE(VB_FILE, LOC_ERR + QString("GetPlaybackURL: '%1' should be "
-                    "local, but it can not be found.").arg(basename));
+            VERBOSE(VB_IMPORTANT, LOC_ERR +
+                    QString("GetPlaybackURL: '%1' should be local, but it can "
+                            "not be found.").arg(basename));
             return QString("/GetPlaybackURL/UNABLE/TO/FIND/LOCAL/FILE/ON/%1/%2")
                            .arg(hostname).arg(basename);
         }
@@ -4165,9 +4171,8 @@
     {
         recDir = "";
     }
-    else if (RemoteCheckFile(this))
+    else if (!gContext->IsBackend() && RemoteCheckFile(this))
     {
-        // if we hit here we're not recording this file
         recDir = pathname.section("/", 0, -2);
     }
 
diff -uNr mythtv-0.21/libs/libmythtv/recordingprofile.cpp mythtv/libs/libmythtv/recordingprofile.cpp
--- mythtv-0.21/libs/libmythtv/recordingprofile.cpp	2007-11-19 17:44:58.000000000 +0100
+++ mythtv/libs/libmythtv/recordingprofile.cpp	2008-12-31 20:00:27.000000000 +0100
@@ -1038,7 +1038,7 @@
 
         QSize defaultsize(768, 576), maxsize(768, 576);
         bool transcoding = profName.left(11) == "Transcoders";
-        bool ivtv = profName.left(34) == "MPEG-2 Encoders (PVR-x50, PVR-500)";
+        bool ivtv = profName.left(20) == "IVTV MPEG-2 Encoders";
 
         if (transcoding)
         {
diff -uNr mythtv-0.21/libs/libmythtv/RingBuffer.cpp mythtv/libs/libmythtv/RingBuffer.cpp
--- mythtv-0.21/libs/libmythtv/RingBuffer.cpp	2008-02-26 22:13:09.000000000 +0100
+++ mythtv/libs/libmythtv/RingBuffer.cpp	2008-06-23 02:35:56.000000000 +0200
@@ -181,17 +181,14 @@
         is_dvd = true;
         dvdPriv = new DVDRingBufferPriv();
         startreadahead = false;
-        int pathLen = filename.find("/", 4);
-        if (pathLen != -1)
-        {
-            QString tempFilename = filename.right(filename.length() -  pathLen);
 
-            QFile checkFile(tempFilename);
-            if (!checkFile.exists())
-                filename = "/dev/dvd";
-            else
-                filename = tempFilename;
-        }
+        if (filename.left(6) == "dvd://")  // 'Play DVD' sends "dvd:/" + dev
+            filename.remove(0,5);          //             e.g. "dvd://dev/sda"
+        else                               // Less correct URI "dvd:" + path
+            filename.remove(0,4);          //             e.g. "dvd:/videos/ET"
+
+        if (QFile::exists(filename))
+            VERBOSE(VB_PLAYBACK, "OpenFile() trying DVD at " + filename);
         else
         {
             filename = "/dev/dvd";
diff -uNr mythtv-0.21/libs/libmythtv/scanwizardhelpers.cpp mythtv/libs/libmythtv/scanwizardhelpers.cpp
--- mythtv-0.21/libs/libmythtv/scanwizardhelpers.cpp	2008-01-14 17:45:33.000000000 +0100
+++ mythtv/libs/libmythtv/scanwizardhelpers.cpp	2009-03-02 15:24:15.000000000 +0100
@@ -1,5 +1,5 @@
 /* -*- Mode: c++ -*-
- * $Id: scanwizardhelpers.cpp 15437 2008-01-14 16:45:33Z danielk $
+ * $Id: scanwizardhelpers.cpp 20088 2009-03-02 14:24:15Z nigel $
  * vim: set expandtab tabstop=4 shiftwidth=4:
  *
  * Original Project
@@ -367,6 +367,8 @@
     int nCardType   = CardUtil::toCardType(subtype);
     clearSelections();
 
+    bool importConf = false;
+
     switch (nCardType)
     {
     case CardUtil::V4L:
@@ -379,27 +381,31 @@
                      QString::number(FullScan_OFDM), true);
         addSelection(tr("Full Scan (Tuned)"),
                      QString::number(NITAddScan_OFDM));
-        addSelection(tr("Import channels.conf"),
-                     QString::number(DVBUtilsImport));
+        importConf = true;
         break;
     case CardUtil::QPSK:
         addSelection(tr("Full Scan (Tuned)"),
                      QString::number(NITAddScan_QPSK));
-        addSelection(tr("Import channels.conf"),
-                     QString::number(DVBUtilsImport));
+        importConf = true;
         break;
     case CardUtil::QAM:
         addSelection(tr("Full Scan (Tuned)"),
                      QString::number(NITAddScan_QAM));
-        addSelection(tr("Import channels.conf"),
-                     QString::number(DVBUtilsImport));
+        importConf = true;
         break;
     case CardUtil::ATSC:
-    case CardUtil::HDHOMERUN:
         addSelection(tr("Full Scan"),
                      QString::number(FullScan_ATSC), true);
-        addSelection(tr("Import channels.conf"),
-                     QString::number(DVBUtilsImport));
+        importConf = true;
+        break;
+    case CardUtil::HDHOMERUN:
+        addSelection(tr("Full Scan (ATSC)"),
+                     QString::number(FullScan_ATSC), true);
+        addSelection(tr("Full Scan (DVB)"),
+                     QString::number(FullScan_OFDM), true);
+        addSelection(tr("Full Scan (DVB, tuned)"),
+                     QString::number(NITAddScan_OFDM));
+        importConf = true;
         break;
     case CardUtil::FREEBOX:
         addSelection(tr("M3U Import"),
@@ -415,6 +421,10 @@
         return;
     }
 
+    if (importConf)
+        addSelection(tr("Import channels.conf"),
+                     QString::number(DVBUtilsImport));
+
     addSelection(tr("Full Scan of Existing Transports"),
                  QString::number(FullTransportScan));
     addSelection(tr("Existing Transport Scan"),
@@ -439,6 +449,10 @@
         country = UK;
     else if (qtcountry == QLocale::Spain)
         country = ES;
+    else if (qtcountry == QLocale::NewZealand)
+        country = NZ;
+    else if (qtcountry == QLocale::France)
+        country = FR;
 #endif
 
     setLabel(tr("Country"));
@@ -448,6 +462,8 @@
     addSelection(QObject::tr("United Kingdom"), "uk", country == UK);
     addSelection(QObject::tr("Germany"),        "de", country == DE);
     addSelection(QObject::tr("Spain"),          "es", country == ES);
+    addSelection(QObject::tr("New Zealand"),    "nz", country == NZ);
+    addSelection(QObject::tr("France"),         "fr", country == FR);
 }
 
 AnalogPane::AnalogPane() :
diff -uNr mythtv-0.21/libs/libmythtv/scanwizardhelpers.h mythtv/libs/libmythtv/scanwizardhelpers.h
--- mythtv-0.21/libs/libmythtv/scanwizardhelpers.h	2008-01-27 20:21:41.000000000 +0100
+++ mythtv/libs/libmythtv/scanwizardhelpers.h	2008-09-27 15:54:35.000000000 +0200
@@ -1,5 +1,5 @@
 /* -*- Mode: c++ -*-
- * $Id: scanwizardhelpers.h 15622 2008-01-27 19:21:41Z danielk $
+ * $Id: scanwizardhelpers.h 18452 2008-09-27 13:54:35Z stuartm $
  * vim: set expandtab tabstop=4 shiftwidth=4:
  *
  * Original Project
@@ -97,7 +97,7 @@
     friend class QObject; // quiet OSX gcc warning
 
   public:
-    enum TYPE 
+    enum TYPE
     {
         ScanComplete,
         ScanShutdown,
@@ -200,6 +200,8 @@
         UK,
         DE,
         ES,
+        NZ,
+        FR,
     };
 
     ScanCountry();
@@ -242,7 +244,7 @@
     uint    hw_cardid;
 };
 
-class ScanOptionalConfig : public TriggeredConfigurationGroup 
+class ScanOptionalConfig : public TriggeredConfigurationGroup
 {
     Q_OBJECT
 
@@ -660,7 +662,7 @@
 class DVBS2Pane : public HorizontalConfigurationGroup
 {
   public:
-    DVBS2Pane() : HorizontalConfigurationGroup(false,false,true,false) 
+    DVBS2Pane() : HorizontalConfigurationGroup(false,false,true,false)
     {
         setUseFrame(false);
         VerticalConfigurationGroup *left =
@@ -674,7 +676,7 @@
         right->addChild(pmodulation = new ScanModulation());
         right->addChild(pinversion  = new ScanInversion());
         addChild(left);
-        addChild(right);     
+        addChild(right);
     }
 
     QString frequency(void)  const { return pfrequency->getValue();  }
@@ -709,7 +711,7 @@
         right->addChild(pfec       = new ScanFec());
         right->addChild(pinversion = new ScanInversion());
         addChild(left);
-        addChild(right);     
+        addChild(right);
     }
 
     QString frequency(void)  const { return pfrequency->getValue();  }
@@ -742,7 +744,7 @@
         right->addChild(pmodulation = new ScanModulation());
         right->addChild(pfec        = new ScanFec());
         addChild(left);
-        addChild(right);     
+        addChild(right);
     }
 
     QString frequency(void)  const { return pfrequency->getValue();  }
diff -uNr mythtv-0.21/libs/libmythtv/siscan.cpp mythtv/libs/libmythtv/siscan.cpp
--- mythtv-0.21/libs/libmythtv/siscan.cpp	2008-01-26 08:29:09.000000000 +0100
+++ mythtv/libs/libmythtv/siscan.cpp	2009-01-02 18:47:09.000000000 +0100
@@ -328,8 +328,6 @@
             .arg((*current).FriendlyName));
     VERBOSE(VB_SIPARSER, LOC + nit->toString());
 
-    dvbChanNums.clear();
-
     if (nit->TransportStreamCount())
     {
         emit TransportScanUpdateText(
@@ -1124,6 +1122,12 @@
     {   // The service is in database, update it
         emit ServiceScanUpdateText(
             tr("Updating %1").arg(common_status_info));
+
+        bool useeit = false;
+        bool hidden = false;
+
+        ChannelUtil::GetChannelSettings(chanid, useeit, hidden);
+
         ChannelUtil::UpdateChannel(
             db_mplexid, db_source_id, chanid,
             callsign,
@@ -1131,7 +1135,7 @@
             chan_num,
             pmt->ProgramNumber(),
             0, 0,
-            false, false, false, QString::number(freqid));
+            useeit, hidden, false, QString::number(freqid));
     }
 }
 
@@ -1510,8 +1514,17 @@
         {   // The service is in database & we have good info, update it
             emit ServiceScanUpdateText(tr("Updating %1").arg(service_name));
 
+            bool useeit = false;
+            bool hidden = false;
+
+            ChannelUtil::GetChannelSettings(chanid, useeit, hidden);
+
             if (!renameChannels)
                 chan_num = ChannelUtil::GetChanNum(chanid);
+            else
+                useeit = (sdt->HasEITSchedule(i) ||
+                            sdt->HasEITPresentFollowing(i) || 
+                            force_guide_present);
 
             ChannelUtil::UpdateChannel(
                 db_mplexid,
@@ -1522,10 +1535,8 @@
                 chan_num,
                 sdt->ServiceID(i),
                 0, 0, 
-                sdt->HasEITSchedule(i) ||
-                sdt->HasEITPresentFollowing(i) ||
-                force_guide_present,
-                false, false, QString::null,
+                useeit,
+                hidden, false, QString::null,
                 QString::null, QString::null, QString::null,
                 default_authority);
         }
diff -uNr mythtv-0.21/libs/libmythtv/textsubtitleparser.cpp mythtv/libs/libmythtv/textsubtitleparser.cpp
--- mythtv-0.21/libs/libmythtv/textsubtitleparser.cpp	2006-09-05 05:49:41.000000000 +0200
+++ mythtv/libs/libmythtv/textsubtitleparser.cpp	2008-08-07 04:41:31.000000000 +0200
@@ -112,7 +112,10 @@
     
     subtitle_t *loaded_subs = sub_read_file(&sub_data);
     if (!loaded_subs)
+    {
+        fclose(sub_data.file_ptr);
         return false;
+    }
 
     target.SetFrameBasedTiming(!sub_data.uses_time);
 
diff -uNr mythtv-0.21/libs/libmythtv/ThreadedFileWriter.cpp mythtv/libs/libmythtv/ThreadedFileWriter.cpp
--- mythtv-0.21/libs/libmythtv/ThreadedFileWriter.cpp	2008-02-24 16:19:20.000000000 +0100
+++ mythtv/libs/libmythtv/ThreadedFileWriter.cpp	2009-04-05 15:33:27.000000000 +0200
@@ -407,7 +407,7 @@
             ignore_writes = true;
         }
 
-        if (written < tfw_min_write_size)
+        if (written <= tfw_min_write_size)
         {
             written += size;
         }
diff -uNr mythtv-0.21/libs/libmythtv/ttfont.cpp mythtv/libs/libmythtv/ttfont.cpp
--- mythtv-0.21/libs/libmythtv/ttfont.cpp	2007-06-08 12:41:38.000000000 +0200
+++ mythtv/libs/libmythtv/ttfont.cpp	2008-04-30 23:45:57.000000000 +0200
@@ -629,10 +629,16 @@
    }
 
    loadedfontsize = (int)(fontsize * m_hmult);
-   xdpi = (int)(xdpi * m_wscale);
 
    FT_Set_Char_Size(face, 0, loadedfontsize * 64, xdpi, ydpi);
 
+   FT_Matrix tmatrix;
+   tmatrix.xx = (FT_Fixed)(m_wscale * (1<<16));
+   tmatrix.yx = (FT_Fixed)0;
+   tmatrix.xy = (FT_Fixed)0;
+   tmatrix.yy = (FT_Fixed)(1<<16);
+   FT_Set_Transform(face, &tmatrix, 0);
+
    n = face->num_charmaps;
 
    for (i = 0; i < n; i++)
diff -uNr mythtv-0.21/libs/libmythtv/tv_play.cpp mythtv/libs/libmythtv/tv_play.cpp
--- mythtv-0.21/libs/libmythtv/tv_play.cpp	2008-03-06 23:23:26.000000000 +0100
+++ mythtv/libs/libmythtv/tv_play.cpp	2009-04-06 21:36:41.000000000 +0200
@@ -3010,7 +3010,7 @@
         return;
 
     if (activerbuffer &&
-        activerbuffer->isDVD() && activerbuffer->DVD()->IsInMenu())
+        activerbuffer->isDVD())
     {
         for (unsigned int i = 0; i < actions.size(); i++)
         {
@@ -5880,10 +5880,14 @@
             break;
         }
         case kScheduleProgramFinder:
+            if (!paused)
+                DoPause(false);
             RunProgramFind(false, false);
             break;
         case kScheduledRecording:
         {
+            if (!paused)
+                DoPause(false);
             QMutexLocker locker(&pbinfoLock);
             ScheduledRecording *record = new ScheduledRecording();
             record->loadByProgram(playbackinfo);
@@ -6291,12 +6295,13 @@
                 message = message.simplifyWhiteSpace();
                 QStringList tokens = QStringList::split(" ", message);
                 int cardnum = tokens[1].toInt();
-                int filelen = tokens[2].toInt();
+                //int seconds = tokens[2].toInt();
+                long long frames = tokens[3].toLongLong();
 
                 if (recorder && cardnum == recorder->GetRecorderNumber())
                 {
                     nvp->SetWatchingRecording(false);
-                    nvp->SetLength(filelen);
+                    nvp->SetLength(frames / nvp->GetFrameRate());
                     ChangeState(kState_WatchingPreRecorded);
                 }
             }
@@ -6305,13 +6310,14 @@
                 message = message.simplifyWhiteSpace();
                 QStringList tokens = QStringList::split(" ", message);
                 int cardnum = tokens[1].toInt();
-                int filelen = tokens[2].toInt();
+                //int seconds = tokens[2].toInt();
+                long long frames = tokens[3].toLongLong();
 
                 if (recorder && cardnum == recorder->GetRecorderNumber() &&
                     tvchain && tvchain->HasNext())
                 {
                     nvp->SetWatchingRecording(false);
-                    nvp->SetLength(filelen);
+                    nvp->SetLength(frames / nvp->GetFrameRate());
                 }
             }
         }
diff -uNr mythtv-0.21/libs/libmythtv/tv_rec.cpp mythtv/libs/libmythtv/tv_rec.cpp
--- mythtv-0.21/libs/libmythtv/tv_rec.cpp	2008-02-07 00:48:47.000000000 +0100
+++ mythtv/libs/libmythtv/tv_rec.cpp	2009-04-06 21:36:41.000000000 +0200
@@ -1072,18 +1072,15 @@
  */
 void TVRec::TeardownRecorder(bool killFile)
 {
-    int filelen = -1;
     pauseNotify = false;
     ispip = false;
 
     if (recorder && HasFlags(kFlagRecorderRunning))
     {
-        // This is a bad way to calculate this, the framerate
-        // may not be constant if using a DTV based recorder.
-        filelen = (int)((float)GetFramesWritten() / GetFramerate());
-
-        QString message = QString("DONE_RECORDING %1 %2")
-            .arg(cardid).arg(filelen);
+        int secsSince = curRecording->recstartts
+            .secsTo(QDateTime::currentDateTime());
+        QString message = QString("DONE_RECORDING %1 %2 %3")
+            .arg(cardid).arg(secsSince).arg(GetFramesWritten());
         MythEvent me(message);
         gContext->dispatch(me);
 
@@ -3668,7 +3665,7 @@
 
     if (!ok)
     {
-        if (!(request.flags & kFlagLiveTV))
+        if (!(request.flags & kFlagLiveTV) || !(request.flags & kFlagEITScan))
         {
             if (curRecording)
                 curRecording->recstatus = rsFailed;
diff -uNr mythtv-0.21/libs/libmythtv/util-opengl.cpp mythtv/libs/libmythtv/util-opengl.cpp
--- mythtv-0.21/libs/libmythtv/util-opengl.cpp	2007-12-12 05:51:42.000000000 +0100
+++ mythtv/libs/libmythtv/util-opengl.cpp	2008-04-02 18:33:07.000000000 +0200
@@ -306,7 +306,9 @@
 {
     __GLXextFuncPtr ret = NULL;
 
-#if GLX_VERSION_1_4
+#if USING_GLX_PROC_ADDR_ARB
+    X11S(ret = glXGetProcAddressARB((const GLubyte*)procName.latin1()));
+#elif GLX_VERSION_1_4
     X11S(ret = glXGetProcAddress((const GLubyte*)procName.latin1()));
 #elif GLX_ARB_get_proc_address
     X11S(ret = glXGetProcAddressARB((const GLubyte*)procName.latin1()));
diff -uNr mythtv-0.21/libs/libmythtv/videooutbase.cpp mythtv/libs/libmythtv/videooutbase.cpp
--- mythtv-0.21/libs/libmythtv/videooutbase.cpp	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/libs/libmythtv/videooutbase.cpp	2009-04-19 23:30:15.000000000 +0200
@@ -1,3 +1,4 @@
+#include <cstdlib>
 #include <cmath>
 
 #include "videooutbase.h"
@@ -510,7 +511,7 @@
     SetupDeinterlace(true, db_vdisp_profile->GetFallbackDeinterlacer());
 }
 
-/** \fn VideoOutput::FallbackDeint(void)
+/** \fn VideoOutput::BestDeint(void)
  *  \brief Change to the best deinterlacing method.
  */
 void VideoOutput::BestDeint(void)
@@ -611,6 +612,8 @@
     db_vdisp_profile->SetInput(video_dim);
 
     SetVideoAspectRatio(aspect);
+
+    BestDeint();
     
     DiscardFrames(true);
 
diff -uNr mythtv-0.21/libs/libmythtv/videoout_d3d.cpp mythtv/libs/libmythtv/videoout_d3d.cpp
--- mythtv-0.21/libs/libmythtv/videoout_d3d.cpp	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/libs/libmythtv/videoout_d3d.cpp	2008-10-16 20:06:20.000000000 +0200
@@ -118,7 +118,7 @@
 {
     QMutexLocker locker(&m_lock);
     VideoOutput::InputChanged(input_size, aspect, av_codec_id, codec_private);
-    db_vdisp_profile->SetVideoRenderer("didect3d");
+    db_vdisp_profile->SetVideoRenderer("direct3d");
 
     if (video_dim.width() == m_InputCX && video_dim.height() == m_InputCY)
     {
